open Printf

let mutex = Mutex.create ()

let log (fmt: ('a, unit, unit) format) : 'a=
  let f s =
    Mutex.lock mutex;
    printf "[%d] %s\n" (Thread.id (Thread.self ())) s;
    flush_all ();
    Mutex.unlock mutex;
    s
  in
  kprintf f (Obj.magic fmt)  (* magic to return unit instead of string *)

