open Log


external testSleep : int -> unit = "testSleep"


let work () =
  while true do
    log "working...";
    Unix.sleep 1
  done
    
let extSleep () =
  let t = 10 in
  log "ext sleep %d sec..." t;
  testSleep t;
  log "ext sleep %d sec: done." t

let main () =
  log "creating threads...";
  let t1 = Thread.create work () in
  let t2 = Thread.create work () in
  let t3 = Thread.create extSleep () in
  log "waiting for threads...";
  Thread.join t1;
  Thread.join t2;
  Thread.join t3;
  log "finished."

;;
main ()
;;
