#include <caml/mlvalues.h>
#include <caml/memory.h>
#include <unistd.h>


#ifdef USE_BLOCKING
void enter_blocking_section();
void leave_blocking_section();
#else
#define enter_blocking_section()
#define leave_blocking_section()
#endif



void testSleep( value timev )
{
  CAMLparam1(timev);
  int time = Int_val(timev);
  enter_blocking_section();
  sleep(time);
  leave_blocking_section();
  CAMLreturn0;
}
